// Copyright 2024 Matthew Rich <matthewrich.conf@gmail.com>. All rights reserved.

package data

import (
	"errors"
)

var (
	ErrInvalidURI error = errors.New("Invalid URI")
)

type Identifier interface {
	URI() string
	SetURI(string) error
}

type Selector[Item comparable] func(r Item) bool

type ResourceSelector Selector[Resource]

type DeclarationSelector Selector[Declaration]
